/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The BanTestAction model module.
 * @module model/BanTestAction
 * @version 1.0.0
 */
class BanTestAction {
    /**
     * Constructs a new <code>BanTestAction</code>.
     * @alias module:model/BanTestAction
     * @param phone {String} A phone number starting with the country code. USA example: \"17472822486\".
     */
    constructor(phone) { 
        
        BanTestAction.initialize(this, phone);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, phone) { 
        obj['phone'] = phone;
    }

    /**
     * Constructs a <code>BanTestAction</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BanTestAction} obj Optional instance to populate.
     * @return {module:model/BanTestAction} The populated <code>BanTestAction</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new BanTestAction();

            if (data.hasOwnProperty('phone')) {
                obj['phone'] = ApiClient.convertToType(data['phone'], 'String');
            }
        }
        return obj;
    }


}

/**
 * A phone number starting with the country code. USA example: \"17472822486\".
 * @member {String} phone
 */
BanTestAction.prototype['phone'] = undefined;






export default BanTestAction;

