/**
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Message model module.
 * @module model/Message
 * @version 1.0.0
 */
class Message {
    /**
     * Constructs a new <code>Message</code>.
     * @alias module:model/Message
     */
    constructor() { 
        
        Message.initialize(this);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj) { 
    }

    /**
     * Constructs a <code>Message</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Message} obj Optional instance to populate.
     * @return {module:model/Message} The populated <code>Message</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Message();

            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('body')) {
                obj['body'] = ApiClient.convertToType(data['body'], 'String');
            }
            if (data.hasOwnProperty('type')) {
                obj['type'] = ApiClient.convertToType(data['type'], 'String');
            }
            if (data.hasOwnProperty('senderName')) {
                obj['senderName'] = ApiClient.convertToType(data['senderName'], 'String');
            }
            if (data.hasOwnProperty('fromMe')) {
                obj['fromMe'] = ApiClient.convertToType(data['fromMe'], 'Boolean');
            }
            if (data.hasOwnProperty('author')) {
                obj['author'] = ApiClient.convertToType(data['author'], 'String');
            }
            if (data.hasOwnProperty('time')) {
                obj['time'] = ApiClient.convertToType(data['time'], 'Number');
            }
            if (data.hasOwnProperty('chatId')) {
                obj['chatId'] = ApiClient.convertToType(data['chatId'], 'String');
            }
            if (data.hasOwnProperty('messageNumber')) {
                obj['messageNumber'] = ApiClient.convertToType(data['messageNumber'], 'Number');
            }
        }
        return obj;
    }


}

/**
 * unique id
 * @member {String} id
 */
Message.prototype['id'] = undefined;

/**
 * text message for type \"chat\", or link to download the file for \"ptt\", \"image\", \"audio\", \"video\" and \"document\", or latitude and longitude for \"location\", or message \"[Call]\" for \"call_log\"
 * @member {String} body
 */
Message.prototype['body'] = undefined;

/**
 * type of the message
 * @member {module:model/Message.TypeEnum} type
 */
Message.prototype['type'] = undefined;

/**
 * Sender name
 * @member {String} senderName
 */
Message.prototype['senderName'] = undefined;

/**
 * true - outgoing, false - incoming
 * @member {Boolean} fromMe
 */
Message.prototype['fromMe'] = undefined;

/**
 * Author ID of the message, useful for groups
 * @member {String} author
 */
Message.prototype['author'] = undefined;

/**
 * send time, unix timestamp
 * @member {Number} time
 */
Message.prototype['time'] = undefined;

/**
 * chat ID
 * @member {String} chatId
 */
Message.prototype['chatId'] = undefined;

/**
 * sequence number of the message in the database
 * @member {Number} messageNumber
 */
Message.prototype['messageNumber'] = undefined;





/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
Message['TypeEnum'] = {

    /**
     * value: "chat"
     * @const
     */
    "chat": "chat",

    /**
     * value: "image"
     * @const
     */
    "image": "image",

    /**
     * value: "ptt"
     * @const
     */
    "ptt": "ptt",

    /**
     * value: "document"
     * @const
     */
    "document": "document",

    /**
     * value: "audio"
     * @const
     */
    "audio": "audio",

    /**
     * value: "video"
     * @const
     */
    "video": "video",

    /**
     * value: "location"
     * @const
     */
    "location": "location",

    /**
     * value: "call_log"
     * @const
     */
    "call_log": "call_log"
};



export default Message;

